Codeforces Round #292 (Div. 2) A,B,C,D 题解

<span style="font-size:14px;">这么早起写个题解还要被审核这么久。我容易吗。。</span>
A. Drazil and Date
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Someday, Drazil wanted to go on date with Varda. Drazil and Varda live on Cartesian plane. Drazil's home is located in point (0, 0) and Varda's home is located in point (a, b). In each step, he can move in a unit distance in horizontal or vertical direction. In other words, from position (x, y) he can go to positions (x + 1, y)(x - 1, y)(x, y + 1) or (x, y - 1).

Unfortunately, Drazil doesn't have sense of direction. So he randomly chooses the direction he will go to in each step. He may accidentally return back to his house during his travel. Drazil may even not notice that he has arrived to (a, b) and continue travelling.

Luckily, Drazil arrived to the position (a, b) successfully. Drazil said to Varda: "It took me exactly s steps to travel from my house to yours". But Varda is confused about his words, she is not sure that it is possible to get from (0, 0) to (a, b) in exactly s steps. Can you find out if it is possible for Varda?

Input

You are given three integers ab, and s ( - 109 ≤ a, b ≤ 1091 ≤ s ≤ 2·109) in a single line.

Output

If you think Drazil made a mistake and it is impossible to take exactly s steps and get from his home to Varda's home, print "No" (without quotes).

Otherwise, print "Yes".

Sample test(s)
input
5 5 11
output
No
input
10 15 25
output
Yes
input
0 5 1
output
No
input
0 0 2
output
Yes
Note

In fourth sample case one possible route is: .

题意:目标点为 ( 0 , 0 ),而你的出发点为 (a, b) ,问 s 步能否到达目标点(0,0) ,能则输出'Yes' ,不能 则输出'No'

题解:水题。只要 a+b 和 s 的奇偶性相同,并且 s >= a + b,就能到达。

#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <sstream>
#define PI acos(-1.0)
const int  inf =  (1<<30) - 10;
using namespace std;

int main()
{
    int x, y, s;
    cin>>x>>y>>s;
    if(x<0)
        x = -x;
    if(y<0)
        y = -y;
    int sum = x + y;
    s = s - sum;
    if(s%2 == 0 && s >= 0)
    {
        cout<<"Yes"<<endl;
    }
    else
    {
        cout<<"No"<<endl;
    }

    return 0;
}

B. Drazil and His Happy Friends
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Drazil has many friends. Some of them are happy and some of them are unhappy. Drazil wants to make all his friends become happy. So he invented the following plan.

There are n boys and m girls among his friends. Let's number them from 0 to n - 1 and 0 to m - 1 separately. In i-th day, Drazil invites -th boy and -th girl to have dinner together (as Drazil is programmer, i starts from 0). If one of those two people is happy, the other one will also become happy. Otherwise, those two people remain in their states. Once a person becomes happy (or if he/she was happy originally), he stays happy forever.

Drazil wants to know whether he can use this plan to make all his friends become happy at some moment.

Input

The first line contains two integer n and m (1 ≤ n, m ≤ 100).

The second line contains integer b (0 ≤ b ≤ n), denoting the number of happy boys among friends of Drazil, and then follow b distinct integers x1, x2, ..., xb (0 ≤ xi < n), denoting the list of indices of happy boys.

The third line conatins integer g (0 ≤ g ≤ m), denoting the number of happy girls among friends of Drazil, and then follow g distinct integersy1, y2, ... , yg (0 ≤ yj < m), denoting the list of indices of happy girls.

It is guaranteed that there is at least one person that is unhappy among his friends.

Output

If Drazil can make all his friends become happy by this plan, print "Yes". Otherwise, print "No".

Sample test(s)
input
2 3
0
1 0
output
Yes
input
2 4
1 0
1 2
output
No
input
2 3
1 0
1 1
output
Yes
Note

By  we define the remainder of integer division of i by k.

In first sample case:

  • On the 0-th day, Drazil invites 0-th boy and 0-th girl. Because 0-th girl is happy at the beginning, 0-th boy become happy at this day.
  • On the 1-st day, Drazil invites 1-st boy and 1-st girl. They are both unhappy, so nothing changes at this day.
  • On the 2-nd day, Drazil invites 0-th boy and 2-nd girl. Because 0-th boy is already happy he makes 2-nd girl become happy at this day.
  • On the 3-rd day, Drazil invites 1-st boy and 0-th girl. 0-th girl is happy, so she makes 1-st boy happy.
  • On the 4-th day, Drazil invites 0-th boy and 1-st girl. 0-th boy is happy, so he makes the 1-st girl happy. So, all friends become happy at this moment.
题意:有 n 个男孩(编号从0开始), m 个女孩;从 第 i  (i从0开始) 天开始, 每次让第 i%n 个男孩去约 第 i%m 个女孩。并且只要其中一个人是“happy” , 则另一个人也会“happy” 。问:不限制 i 的上限,到最后是否可以让所有人都 “happy”。

题解:水题。暴力模拟即可。

#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <sstream>
#define PI acos(-1.0)
const int  inf =  (1<<30) - 10;
using namespace std;

int gcd (int a, int b)
{
	return b == 0 ? a : gcd (b, a % b);
}

bool vis1[110];
bool vis2[110];

int main()
{
    int n, m;
    cin>>n>>m;
    for(int i = 0;i <= n; ++i)
        vis1[i] = false;
    for(int i = 0;i <= m; ++i)
        vis2[i] = false;
    int b, g, x;
    cin>>b;
    for(int i = 0;i < b; ++i)
    {
        scanf("%d",&x);
        vis1[x] = true;
    }
    cin>>g;
    for(int i = 0;i < g; ++i)
    {
        scanf("%d",&x);
        vis2[x] = true;
    }
    int temp = 0;
    int t = gcd(n,m);
    t = (n*m)/t; //直接令 t 等于 10000也是可以过的。此题数据较水
    while(temp < t + 100)
    {
        int kn = temp%n;
        int km = temp%m;
        if(vis1[kn] || vis2[km])
        {
            vis1[kn] = vis2[km] = true;
        }
        temp++;
    }
    int judge = 0;
    for(int i = 0;i < n; ++i)
        if(!vis1[i])
            judge++;
    for(int i = 0;i < m; ++i)
        if(!vis2[i])
            judge++;
    if(judge)
    {
        cout<<"No"<<endl;
        return 0;
    }
    cout<<"Yes"<<endl;
    return 0;
}

C. Drazil and Factorial
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Drazil is playing a math game with Varda.

Let's define  for positive integer x as a product of factorials of its digits. For example, .

First, they choose a decimal number a consisting of n digits that contains at least one digit larger than 1. This number may possibly start with leading zeroes. Then they should find maximum positive number x satisfying following two conditions:

1. x doesn't contain neither digit 0 nor digit 1.

2.  = .

Help friends find such number.

Input

The first line contains an integer n (1 ≤ n ≤ 15) — the number of digits in a.

The second line contains n digits of a. There is at least one digit in a that is larger than 1. Number a may possibly contain leading zeroes.

Output

Output a maximum possible integer satisfying the conditions above. There should be no zeroes and ones in this number decimal representation.

Sample test(s)
input
4
1234
output
33222
input
3
555
output
555
Note

In the first case, 

题意:定义. ,问你,找出一个F(a) =  F(x) ,为了更好的解释,假设这个x 等于 1234. 则F(x) =  288; 我们可以找到一个最大的满足条件的数 a = 33222。因为F(a) = 288;

题解:水题。分解一下数字就可以了。

//1! = 0! = 1

//2! = 2!

//3! = 3!

//4! = 3! * 2! * 2!

//5! = 5!

//6! = 5! * 3!

//7! = 7!

//8! = 7! * 2! * 2! * 2!

//9! = 7! * 3! * 3! * 2!

用一个数组记录一下可能出现的所有数字的个数,然后逆着输出便可。

#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <sstream>
#define PI acos(-1.0)
const int  inf =  (1<<30) - 10;
using namespace std;

int vis[11];

int main()
{
    int n;
    char str[100];
    for(int i = 0;i < 11; ++i)
        vis[i] = 0;
    cin>>n;
    scanf("%s",str);
    for(int i = 0;i < n; ++i)
    {
        if(str[i] == '2')
        {
            vis[2]++;
        }
        else if(str[i] == '3')
        {
            vis[3]++;
        }
        else if(str[i] == '4')
        {
            vis[3]++;
            vis[2] = vis[2] + 2;
        }
        else if(str[i] == '5')
        {
            vis[5]++;
        }
        else if(str[i] == '6')
        {
            vis[5]++;
            vis[3]++;
        }
        else if(str[i] == '7')
        {
            vis[7]++;
        }
        else if(str[i] == '8')
        {
            vis[7]++;
            vis[2] = vis[2] + 3;
        }
        else if(str[i] == '9')
        {
            vis[7]++;
            vis[3] = vis[3] + 2;
            vis[2]++;
        }
    }
    for(int i = 10;i >= 0; --i)
    {
        if(vis[i])
        {
            while(vis[i])
            {
                cout<<i;
                vis[i]--;
            }
        }
    }
    cout<<endl;
    return 0;
}

D. Drazil and Tiles
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Drazil created a following problem about putting 1 × 2 tiles into an n × m grid:

"There is a grid with some cells that are empty and some cells that are occupied. You should use 1 × 2 tiles to cover all empty cells and no two tiles should cover each other. And you should print a solution about how to do it."

But Drazil doesn't like to write special checking program for this task. His friend, Varda advised him: "how about asking contestant only to print the solution when it exists and it is unique? Otherwise contestant may print 'Not unique' ".

Drazil found that the constraints for this task may be much larger than for the original task!

Can you solve this new problem?

Note that you should print 'Not unique' either when there exists no solution or when there exists several different solutions for the original task.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 2000).

The following n lines describe the grid rows. Character '.' denotes an empty cell, and the character '*' denotes a cell that is occupied.

Output

If there is no solution or the solution is not unique, you should print the string "Not unique".

Otherwise you should print how to cover all empty cells with 1 × 2 tiles. Use characters "<>" to denote horizontal tiles and characters "^v" to denote vertical tiles. Refer to the sample test for the output format example.

Sample test(s)
input
3 3
...
.*.
...
output
Not unique
input
4 4
..**
*...
*.**
....
output
<>**
*^<>
*v**
<><>
input
2 4
*..*
....
output
*<>*
<><>
input
1 1
.
output
Not unique
input
1 1
*
output
*
Note

In the first case, there are indeed two solutions:

<>^
^*v
v<>

and

^<>
v*^
<>v

so the answer is "Not unique".


题意:有一种1 x  2 的瓷砖,横放或者竖放的铺在一个 N x M 的图中,注:只有“.”才能铺,砖与砖之间不能交错。问:是否有唯一的一种铺砖方法铺满这个N x M 的图。有则输出用这种方法铺砖后的图,否则输出“Not unique

题解:贪心 + dfs 。如果有唯一的铺砖方法,则所有的“.”必定有唯一的横放或者竖放的瓷砖铺在上面,对这个 N x M 的图进行 DFS 每次对有且仅有一种铺砖方法的点进行处理。

#include <iostream>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <sstream>
#define PI acos(-1.0)
const int  inf =  (1<<30) - 10;
using namespace std;

const int maxx = 2000 + 10;
int dir[4][2] = {{1,0},{-1,0},{0,1},{0,-1}};
int vis[maxx][maxx];
char str[maxx];
int n, m;
int cnt;

void dfs(int x,int y)
{
    if(x < 1 || x > n || y < 1|| y > m || vis[x][y])
        return ;


    int dx = -1;
    int dy = -1;
    int kjudge = 0;
    for(int dd = 0; dd < 4; ++dd)
    {
        int hx = x + dir[dd][0];
        int hy = y + dir[dd][1];
        if(vis[hx][hy]==0)
        {
            if(kjudge)
            {
                kjudge = 0;
                break;
            }
            else kjudge = dd + 1;

            dx = dir[dd][0];
            dy = dir[dd][1];
        }
    }
    if(kjudge)
    {
        if(kjudge == 2)
        {
            vis[x][y] = 3;
            vis[x + dx][y + dy] = 2;
        }
        else if(kjudge == 1)
        {
            vis[x][y] = 2;
            vis[x + dx][y + dy] = 3;
        }
        else if(kjudge == 3)
        {
            vis[x][y] = 5;
            vis[x + dx][y + dy] = 4;
        }
        else if(kjudge == 4)
        {
            vis[x][y] = 4;
            vis[x + dx][y + dy] = 5;
        }
        cnt += 2;
        for(int i = 0; i < 4; ++i)
            dfs(x + dir[kjudge - 1][0] + dir[i][0],y + dir[kjudge - 1][1] + dir[i][1] );
    }
}

int main()
{
    cin>>n>>m;
    for(int i = 0; i <= n + 1; ++i)
    {
        for(int j = 0; j <= m + 1; ++j)
        {
            vis[i][j] = 1;
        }
    }
    cnt = 0;
    for(int i = 1; i <= n; ++i)
    {
        scanf("%s",str);
        for(int j = 0; j < m; ++j)
        {
            if(str[j] == '.')
            {
                vis[i][j + 1] = 0;
            }
            else
            {
                cnt++;
            }
        }
    }
    for(int i = 1; i <= n; ++i)
    {
        for(int j = 1; j <= m; ++j)
        {
            dfs(i,j);
        }
    }
    if(cnt != n * m)
    {
        cout<<"Not unique"<<endl;
    }
    else
    {
        for(int i = 1; i <= n; ++i)
        {
            for(int j = 1; j <= m; ++j)
            {
                if(vis[i][j] == 1)
                {
                    cout<<"*";
                }
                else if(vis[i][j] == 2)
                {
                    cout<<"^";
                }
                else if(vis[i][j] == 3)
                {
                    cout<<"v";
                }
                else if(vis[i][j] == 4)
                {
                    cout<<">";
                }
                else if(vis[i][j] == 5)
                {
                    cout<<"<";
                }
            }
            cout<<endl;
        }
    }
    return 0;
}

本来D题有着充足的时间,但是看完题目后感觉没有思路,就跑去HACK别人的B题。

后来想挣扎一下,就继续回去看D。结果、、


比赛结束前20分钟的时候想到了思路。愣是在比赛结束后4分钟左右才写出来。

难道这就是对我这种题目都还没写完,就跑去HACK别人的人的惩罚吗。。。。。

上次看到别人的代码中的一行注释:妈妈说HACK别人的孩子不是好孩子,会遭报应的。= =

这次果断遭报应了。。。


如有BUG,欢迎指出!

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值